#include <stdio.h>
#include <string.h>
#include <gemx.h>

#define MY_PRINT_DEVICE	21

short work_in[11];
short work_out[57];
short nb_color_vdi;		
short height_prn,width_prn;
short handle;
short dummy, cheight;

void open_work( short dev_number )
{ 
    short i;
    for (i=0;i<10;work_in[i++]=1);
        work_in[10]=2;

    work_in[0]=dev_number;			

  v_opnwk(work_in,&handle,work_out);
  nb_color_vdi=work_out[13];	
 	height_prn=work_out[1]+1;		
 	width_prn=work_out[0]+1;		
	printf("\r\nhandle=%d paper = %dx%d   #ofcolour=%d\n\r",handle, width_prn,height_prn, nb_color_vdi);
		
};

int  main( void )
{	
	short i, id, p_xy[4];
	char mystr[256];
	char  txt[33]="";
	long ln;

	open_work(MY_PRINT_DEVICE);

	p_xy[0] = 0;
	p_xy[1] = 0;
	p_xy[2] = width_prn-1;
	p_xy[3] = height_prn-1;
	
	//
	// 1. comment the 2 vs_clip below to make it print out full PDF at high DPI
	// 2. uncomment the 2 vs_clip below to make it print out clipped text PDF at high DPI
	//vs_clip(handle, 1, p_xy);
	//vs_clip(handle, 0, p_xy);
	
	vswr_mode ( handle, MD_REPLACE);

	id = vqt_name( handle, 2, txt);
	vst_font( handle, id);
	vst_arbpt( handle,14,&dummy,&dummy,&dummy,&cheight);
	printf("font = %s  pts=%d\n\r", txt, cheight); 
		
	for (i=1, ln = cheight; i < 75; i++) {
		if ( ln > height_prn) {
			v_updwk(handle); ln = cheight;
		}
		sprintf(mystr, "This is line %d at (50,%3li) and the quick brown fox jump over the lazy pig.", i, ln);
		v_ftext( handle, 50, ln,  mystr);
		ln += cheight;
	}

	v_updwk(handle);
	v_clrwk(handle);
	v_clswk(handle);
	return 0;
}